#include <string.h>
#include <unistd.h>

#include <systypes/fcntl.h>

#include "debug.h"

/* Messages. */

char message[] = "Hello file!\n";
char addition[] = " Goodbye from file!\n";



/* Read from the file. */

static void read_file(int fd)
{
  char buffer[100];
  int available = read(fd, buffer, 100);

  if (available == -1)
    debug("Failed to read file!\n");
  else if (!available)
    debug("Nothing read.\n");
  else
    debug_len(buffer, available);
}

/* Main program. */

int main(int argc, char *argv[], char *envp[])
{
  int fd;
  off_t pos;

  if (argc < 2)
  {
    debug("No filename specified!\n");
    return 1;
  }

  fd = open(argv[1], O_CREAT | O_RDWR);

  if (fd == -1)
  {
    debug("Failed to open file!\n");
    return 1;
  }

  /* Write and then read back. */

  if (write(fd, message, strlen(message)) == -1)
  {
    debug("Failed to write to file!\n");
    return 1;
  }

  if (lseek(fd, 0, SEEK_SET) == -1)
  {
    debug("Failed to seek relative to start of file!\n");
    return 1;
  }

  read_file(fd);

  pos = lseek(fd, -1, SEEK_END);
  if (pos == -1)
  {
    debug("Failed to seek relative to end of file!\n");
    return 1;
  }

  if (write(fd, addition, strlen(addition)) == -1)
  {
    debug("Failed to write to file!\n");
    return 1;
  }

  if (lseek(fd, 0, SEEK_SET) == -1)
  {
    debug("Failed to seek relative to start of file!\n");
    return 1;
  }

  read_file(fd);

  if (close(fd) == -1)
  {
    debug("Failed to close file!\n");
    return 1;
  }

  /* Finish off. */

  debug("At end of program!\n");

  return 0;
}
