#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>

#include "debug.h"

#define logprintf(fmt, ...) sprintf(buffer, fmt, __VA_ARGS__); debug(buffer);



/* Main program. */

int main(int argc, char *argv[], char *envp[])
{
  char buffer[32];
  struct stat st;

  if (argc < 2)
  {
    debug("No filename given.\n");
    return 1;
  }

  if (stat(argv[1], &st))
  {
    debug("Failed to get metadata.\n");
    return 1;
  }

  logprintf("mode: %o\n", st.st_mode);
  logprintf("uid: %d\n", st.st_uid);
  logprintf("gid: %d\n", st.st_gid);
  logprintf("size: %ld\n", st.st_size);

  /* Finish off. */

  debug("At end of program!\n");

  return 0;
}
